/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved.
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.lib.basic.filters.AccumulateTimesteps;

import javax.swing.DefaultCellEditor;
import javax.swing.ImageIcon;
import javax.swing.JTable;
import javax.swing.event.TableModelEvent;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;
import javax.swing.table.TableModel;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.gui.icons.IconsContainer;
import org.visnow.vn.gui.widgets.SteppedComboBox;
import org.visnow.vn.lib.basic.filters.AccumulateTimesteps.AccumulateTimesteps.State;
import org.visnow.vn.lib.utils.field.MergeTimesteps.Action;
import static org.visnow.vn.lib.basic.filters.AccumulateTimesteps.AccumulateTimestepsShared.*;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 */
public class GUI extends javax.swing.JPanel
{

    private static final String[] ACTION_TABLE_HEADER =    new String[]{"component",  "action"};
    private static final int[]    ACTION_TABLE_COL_WIDTH = new int[]   {150,          50};
    private static final Class[]  ACTION_TABLE_TYPES =     new Class[] {String.class, Action.class};

    private Object[][] actionTableContent = new Object[1][2];

    private ParameterProxy parameterProxy;

    /**
     * Creates new form GUI
     */
    public GUI()
    {
        initComponents();
        actionTable.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
        SteppedComboBox comboBox = new SteppedComboBox(Action.values());
        setUpComponentColumn(comboBox, actionTable.getColumnModel().getColumn(1));
        for (int i = 0; i < ACTION_TABLE_COL_WIDTH.length; i++) {
            TableColumn column = actionTable.getColumnModel().getColumn(i);
            column.setPreferredWidth(ACTION_TABLE_COL_WIDTH[i]);
        }
        actionTable.doLayout();
    }

    private void setUpComponentColumn(SteppedComboBox comboBox,
                                      TableColumn componentColumn)
    {
        componentColumn.setCellEditor(new DefaultCellEditor(comboBox));
        DefaultTableCellRenderer renderer
            = new DefaultTableCellRenderer();
        componentColumn.setCellRenderer(renderer);
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        actionTable = new javax.swing.JTable();
        timeIncrementSlider = new org.visnow.vn.gui.widgets.ExtendedSlider();
        jLabel1 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        resetButton = new javax.swing.JButton();
        accumulateButton = new javax.swing.JButton();
        pauseButton = new javax.swing.JButton();
        stateLabel = new javax.swing.JLabel();
        clipboardButton = new javax.swing.JButton();

        setLayout(new java.awt.GridBagLayout());

        jPanel1.setToolTipText("no input or null input field");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        add(jPanel1, gridBagConstraints);

        jScrollPane1.setMinimumSize(new java.awt.Dimension(100, 60));
        jScrollPane1.setPreferredSize(new java.awt.Dimension(200, 150));

        actionTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][]
            {
                {null, null},
                {null, null},
                {null, null},
                {null, null}
            },
            new String []
            {
                "component", "action"
            }
        )
        {
            Class[] types = new Class []
            {
                java.lang.String.class, java.lang.Object.class
            };
            boolean[] canEdit = new boolean []
            {
                false, true
            };

            public Class getColumnClass(int columnIndex)
            {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex)
            {
                return canEdit [columnIndex];
            }
        });
        jScrollPane1.setViewportView(actionTable);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        add(jScrollPane1, gridBagConstraints);

        timeIncrementSlider.setFieldType(org.visnow.vn.gui.components.NumericTextField.FieldType.FLOAT);
        timeIncrementSlider.setGlobalMax(10);
        timeIncrementSlider.setGlobalMin(.001);
        timeIncrementSlider.setMax(10);
        timeIncrementSlider.setMin(.001);
        timeIncrementSlider.setScaleType(org.visnow.vn.gui.widgets.ExtendedSlider.ScaleType.LOGARITHMIC);
        timeIncrementSlider.setValue(1);
        timeIncrementSlider.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                timeIncrementSliderUserAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(timeIncrementSlider, gridBagConstraints);

        jLabel1.setText("time increment");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_START;
        gridBagConstraints.insets = new java.awt.Insets(7, 6, 0, 0);
        add(jLabel1, gridBagConstraints);

        jPanel2.setLayout(new java.awt.GridBagLayout());

        resetButton.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        resetButton.setText("reset");
        resetButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                resetButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(resetButton, gridBagConstraints);

        accumulateButton.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        accumulateButton.setText("accumulate");
        accumulateButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                accumulateButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(accumulateButton, gridBagConstraints);

        pauseButton.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        pauseButton.setText("pause");
        pauseButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                pauseButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(pauseButton, gridBagConstraints);

        stateLabel.setBackground(java.awt.Color.lightGray);
        stateLabel.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        stateLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        stateLabel.setIcon(new ImageIcon(IconsContainer.getBallRed()));
        stateLabel.setText("<html>Waiting: <p>set actions for components <p>and click <b>accumulate</b></html>");
        stateLabel.setMaximumSize(new java.awt.Dimension(300, 90));
        stateLabel.setMinimumSize(new java.awt.Dimension(150, 50));
        stateLabel.setPreferredSize(new java.awt.Dimension(200, 55));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 4, 0, 2);
        jPanel2.add(stateLabel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(jPanel2, gridBagConstraints);

        clipboardButton.setText("copy output to clipboard");
        clipboardButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                clipboardButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(clipboardButton, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void resetButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_resetButtonActionPerformed
    {//GEN-HEADEREND:event_resetButtonActionPerformed
        if (parameterProxy != null)
            parameterProxy.set(RESET, true);
    }//GEN-LAST:event_resetButtonActionPerformed

    private void timeIncrementSliderUserAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_timeIncrementSliderUserAction
    {//GEN-HEADEREND:event_timeIncrementSliderUserAction
        if (parameterProxy != null)
            parameterProxy.set(TIME_INCREMENT, timeIncrementSlider.getValue().floatValue());
    }//GEN-LAST:event_timeIncrementSliderUserAction

    private void accumulateButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_accumulateButtonActionPerformed
    {//GEN-HEADEREND:event_accumulateButtonActionPerformed
        if (parameterProxy != null) {
            Action[] actions = parameterProxy.get(ACTIONS);
            for (int i = 0; i < actions.length; i++)
                actions[i] = (Action)actionTable.getModel().getValueAt(i, 1);
            parameterProxy.set(ACTIONS, actions);
            parameterProxy.set(ACCUMULATE_INPUTS, true);
        }
    }//GEN-LAST:event_accumulateButtonActionPerformed

    private void pauseButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_pauseButtonActionPerformed
    {//GEN-HEADEREND:event_pauseButtonActionPerformed
        if (parameterProxy != null)
            parameterProxy.set(PAUSE, true);
    }//GEN-LAST:event_pauseButtonActionPerformed

    private void clipboardButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_clipboardButtonActionPerformed
    {//GEN-HEADEREND:event_clipboardButtonActionPerformed
        if (parameterProxy != null)
            parameterProxy.set(TO_CLIPBOARD, true);
    }//GEN-LAST:event_clipboardButtonActionPerformed

    public void setParameterProxy(ParameterProxy parameterProxy)
    {
        //putting run button between logic and gui
        this.parameterProxy = parameterProxy;
    }

    void updateGUI(final ParameterProxy p, boolean resetFully)
    {
        String[] names = p.get(ITEMS);
        Action[] actions = p.get(ACTIONS);
        actionTableContent = new Object[names.length][2];
        for (int i = 0; i < actionTableContent.length; i++) {
            actionTableContent[i][0] = names[i];
            actionTableContent[i][1] = actions[i];
        }
        TableModel model = new DefaultTableModel(actionTableContent, ACTION_TABLE_HEADER)
        {
            @Override
            public Class getColumnClass(int columnIndex)
            {
                return ACTION_TABLE_TYPES[columnIndex];
            }
            @Override
            public boolean isCellEditable(int rowIndex, int columnIndex)
            {
                return columnIndex == 1;
            }
        };
        model.addTableModelListener((TableModelEvent e) -> {
            for (int i = 0; i < actions.length; i ++)
                actions[i] =  (Action)actionTableContent[i][1];
        });
        actionTable.setModel(model);
        actionTable.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
        SteppedComboBox comboBox = new SteppedComboBox(Action.values());
        setUpComponentColumn(comboBox, actionTable.getColumnModel().getColumn(1));
        for (int i = 0; i < ACTION_TABLE_COL_WIDTH.length; i++) {
            TableColumn column = actionTable.getColumnModel().getColumn(i);
            column.setPreferredWidth(ACTION_TABLE_COL_WIDTH[i]);
        }
        actionTable.doLayout();
    }

    public void setState(State state)
    {
        switch (state) {
            case NO_INPUT:
                stateLabel.setIcon(new ImageIcon(IconsContainer.getBallRed()));
                stateLabel.setText("<html>No valid input field<p>");
                actionTable.setEnabled(false);
                resetButton.setEnabled(false);
                accumulateButton.setEnabled(false);
                pauseButton.setEnabled(false);
                clipboardButton.setEnabled(false);
                break;
            case EMPTY_SELECTION:
                stateLabel.setIcon(new ImageIcon(IconsContainer.getBallRed()));
                stateLabel.setText("<html>Empty selection:<p>at least one component must be <p>not <b>ignored</b></html>");
                actionTable.setEnabled(true);
                resetButton.setEnabled(false);
                accumulateButton.setEnabled(true);
                pauseButton.setEnabled(false);
                clipboardButton.setEnabled(false);
                break;
            case WAITING:
                stateLabel.setIcon(new ImageIcon(IconsContainer.getBallYellow()));
                stateLabel.setText("<html>Waiting: <p>set actions for components <p>and click <b>accumulate</b></html>");
                actionTable.setEnabled(true);
                resetButton.setEnabled(false);
                accumulateButton.setEnabled(true);
                pauseButton.setEnabled(false);
                clipboardButton.setEnabled(false);
                break;
            case ACCUMULATING:
                stateLabel.setIcon(new ImageIcon(IconsContainer.getBallGreen()));
                stateLabel.setText("<html>Accumulating:<p>Click <b>pause</b> to suspend<p>click <b>reset</b> to clear output and restart</html>");
                actionTable.setEnabled(false);
                resetButton.setEnabled(true);
                accumulateButton.setEnabled(false);
                pauseButton.setEnabled(true);
                clipboardButton.setEnabled(true);
                break;
            case PAUSED:
                stateLabel.setIcon(new ImageIcon(IconsContainer.getBallLight()));
                stateLabel.setText("<html>Pausing: <p>Click <b>accumulate</b> to continue <p>Click <b>reset</b> to clear output and restart</html>");
                actionTable.setEnabled(false);
                resetButton.setEnabled(true);
                accumulateButton.setEnabled(true);
                pauseButton.setEnabled(false);
                clipboardButton.setEnabled(true);
                break;
            case BAD_INPUT:
                stateLabel.setIcon(new ImageIcon(IconsContainer.getBallOrange()));
                stateLabel.setToolTipText("<html>Incompatible input:<p>Click <b>accumulate</b> to skip and continue<p>click <b>reset</b> to clear output and restart./html>");
                actionTable.setEnabled(false);
                resetButton.setEnabled(true);
                accumulateButton.setEnabled(true);
                pauseButton.setEnabled(false);
                clipboardButton.setEnabled(true);
                break;
        }
    }

    public void update()
    {
        String[] names = parameterProxy.get(ITEMS);
        Action[] actions = parameterProxy.get(ACTIONS);
        actionTableContent = new Object[names.length][2];
        for (int i = 0; i < actionTableContent.length; i++) {
            actionTableContent[i][0] = names[i];
            actionTableContent[i][1] = actions[i];
        }
        TableModel model = new DefaultTableModel(actionTableContent, ACTION_TABLE_HEADER)
        {
            @Override
            public Class getColumnClass(int columnIndex)
            {
                return ACTION_TABLE_TYPES[columnIndex];
            }
            @Override
            public boolean isCellEditable(int rowIndex, int columnIndex)
            {
                return columnIndex == 1;
            }
        };
        model.addTableModelListener((TableModelEvent e) -> {
            for (int i = 0; i < actions.length; i ++)
                actions[i] =  (Action)actionTableContent[i][1];
        });
        actionTable.setModel(model);
        actionTable.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
        SteppedComboBox comboBox = new SteppedComboBox(Action.values());
        setUpComponentColumn(comboBox, actionTable.getColumnModel().getColumn(1));
        for (int i = 0; i < ACTION_TABLE_COL_WIDTH.length; i++) {
            TableColumn column = actionTable.getColumnModel().getColumn(i);
            column.setPreferredWidth(ACTION_TABLE_COL_WIDTH[i]);
        }
        actionTable.doLayout();
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton accumulateButton;
    private javax.swing.JTable actionTable;
    private javax.swing.JButton clipboardButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JButton pauseButton;
    private javax.swing.JButton resetButton;
    private javax.swing.JLabel stateLabel;
    private org.visnow.vn.gui.widgets.ExtendedSlider timeIncrementSlider;
    // End of variables declaration//GEN-END:variables

}
